#pragma once

// From GLFW
#define DEER_KEY_SPACE              32
#define DEER_KEY_APOSTROPHE         39  /* ' */
#define DEER_KEY_COMMA              44  /* , */
#define DEER_KEY_MINUS              45  /* - */
#define DEER_KEY_PERIOD             46  /* . */
#define DEER_KEY_SLASH              47  /* / */
#define DEER_KEY_0                  48
#define DEER_KEY_1                  49
#define DEER_KEY_2                  50
#define DEER_KEY_3                  51
#define DEER_KEY_4                  52
#define DEER_KEY_5                  53
#define DEER_KEY_6                  54
#define DEER_KEY_7                  55
#define DEER_KEY_8                  56
#define DEER_KEY_9                  57
#define DEER_KEY_SEMICOLON          59  /* ; */
#define DEER_KEY_EQUAL              61  /* = */
#define DEER_KEY_A                  65
#define DEER_KEY_B                  66
#define DEER_KEY_C                  67
#define DEER_KEY_D                  68
#define DEER_KEY_E                  69
#define DEER_KEY_F                  70
#define DEER_KEY_G                  71
#define DEER_KEY_H                  72
#define DEER_KEY_I                  73
#define DEER_KEY_J                  74
#define DEER_KEY_K                  75
#define DEER_KEY_L                  76
#define DEER_KEY_M                  77
#define DEER_KEY_N                  78
#define DEER_KEY_O                  79
#define DEER_KEY_P                  80
#define DEER_KEY_Q                  81
#define DEER_KEY_R                  82
#define DEER_KEY_S                  83
#define DEER_KEY_T                  84
#define DEER_KEY_U                  85
#define DEER_KEY_V                  86
#define DEER_KEY_W                  87
#define DEER_KEY_X                  88
#define DEER_KEY_Y                  89
#define DEER_KEY_Z                  90
#define DEER_KEY_LEFT_BRACKET       91  /* [ */
#define DEER_KEY_BACKSLASH          92  /* \ */
#define DEER_KEY_RIGHT_BRACKET      93  /* ] */
#define DEER_KEY_GRAVE_ACCENT       96  /* ` */
#define DEER_KEY_WORLD_1            161 /* non-US #1 */
#define DEER_KEY_WORLD_2            162 /* non-US #2 */

/* Function keys */
#define DEER_KEY_ESCAPE             256
#define DEER_KEY_ENTER              257
#define DEER_KEY_TAB                258
#define DEER_KEY_BACKSPACE          259
#define DEER_KEY_INSERT             260
#define DEER_KEY_DELETE             261
#define DEER_KEY_RIGHT              262
#define DEER_KEY_LEFT               263
#define DEER_KEY_DOWN               264
#define DEER_KEY_UP                 265
#define DEER_KEY_PAGE_UP            266
#define DEER_KEY_PAGE_DOWN          267
#define DEER_KEY_HOME               268
#define DEER_KEY_END                269
#define DEER_KEY_CAPS_LOCK          280
#define DEER_KEY_SCROLL_LOCK        281
#define DEER_KEY_NUM_LOCK           282
#define DEER_KEY_PRINT_SCREEN       283
#define DEER_KEY_PAUSE              284
#define DEER_KEY_F1                 290
#define DEER_KEY_F2                 291
#define DEER_KEY_F3                 292
#define DEER_KEY_F4                 293
#define DEER_KEY_F5                 294
#define DEER_KEY_F6                 295
#define DEER_KEY_F7                 296
#define DEER_KEY_F8                 297
#define DEER_KEY_F9                 298
#define DEER_KEY_F10                299
#define DEER_KEY_F11                300
#define DEER_KEY_F12                301
#define DEER_KEY_F13                302
#define DEER_KEY_F14                303
#define DEER_KEY_F15                304
#define DEER_KEY_F16                305
#define DEER_KEY_F17                306
#define DEER_KEY_F18                307
#define DEER_KEY_F19                308
#define DEER_KEY_F20                309
#define DEER_KEY_F21                310
#define DEER_KEY_F22                311
#define DEER_KEY_F23                312
#define DEER_KEY_F24                313
#define DEER_KEY_F25                314
#define DEER_KEY_KP_0               320
#define DEER_KEY_KP_1               321
#define DEER_KEY_KP_2               322
#define DEER_KEY_KP_3               323
#define DEER_KEY_KP_4               324
#define DEER_KEY_KP_5               325
#define DEER_KEY_KP_6               326
#define DEER_KEY_KP_7               327
#define DEER_KEY_KP_8               328
#define DEER_KEY_KP_9               329
#define DEER_KEY_KP_DECIMAL         330
#define DEER_KEY_KP_DIVIDE          331
#define DEER_KEY_KP_MULTIPLY        332
#define DEER_KEY_KP_SUBTRACT        333
#define DEER_KEY_KP_ADD             334
#define DEER_KEY_KP_ENTER           335
#define DEER_KEY_KP_EQUAL           336
#define DEER_KEY_LEFT_SHIFT         340
#define DEER_KEY_LEFT_CONTROL       341
#define DEER_KEY_LEFT_ALT           342
#define DEER_KEY_LEFT_SUPER         343
#define DEER_KEY_RIGHT_SHIFT        344
#define DEER_KEY_RIGHT_CONTROL      345
#define DEER_KEY_RIGHT_ALT          346
#define DEER_KEY_RIGHT_SUPER        347
#define DEER_KEY_MENU               348

#define DEER_MOUSE_BUTTON_1         0
#define DEER_MOUSE_BUTTON_2         1
#define DEER_MOUSE_BUTTON_3         2
#define DEER_MOUSE_BUTTON_4         3
#define DEER_MOUSE_BUTTON_5         4
#define DEER_MOUSE_BUTTON_6         5
#define DEER_MOUSE_BUTTON_7         6
#define DEER_MOUSE_BUTTON_8         7
#define DEER_MOUSE_BUTTON_LAST      DEER_MOUSE_BUTTON_8
#define DEER_MOUSE_BUTTON_LEFT      DEER_MOUSE_BUTTON_1
#define DEER_MOUSE_BUTTON_RIGHT     DEER_MOUSE_BUTTON_2
#define DEER_MOUSE_BUTTON_MIDDLE    DEER_MOUSE_BUTTON_3